{21}
unit Main;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls, Contnrs, ComCtrls;

const
  nic=0;
  silnice=1;
  examplesilnice=2;
  cil=3;
  col:array[0..3] of TColor=(clBlack, clLtGray,clWhite, clGreen);
  maxword=$FFFF;

type
  TState=Word;

  TForm1 = class(TForm)
    Button1: TButton;
    OpenDialog1: TOpenDialog;
    Panel1: TPanel;
    ScrollBox1: TScrollBox;
    Image1: TImage;
    Label1: TLabel;
    Button2: TButton;
    Memo1: TMemo;
    ScrollBar1: TScrollBar;
    Label2: TLabel;
    Button3: TButton;
    Button4: TButton;
    OpenDialog2: TOpenDialog;
    SaveDialog1: TSaveDialog;
    ProgressBar1: TProgressBar;
    procedure Button1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure ScrollBar1Change(Sender: TObject);
    procedure SavePathClick(Sender: TObject);
    procedure Button4Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
    map,path:TStringList;
    sizex,sizey:Integer;
    startx,starty:Integer;
    fspacex,fspacey,fspaces,fspacevx,fspacevy:Integer;
    sum:integer;
    mapspace:array[0..254,0..254] of byte;
    heurhl:Integer;
    cisto:boolean;
    heur0:array[0..254,0..254] of Integer;
    heur1:array[0..254,0..254] of Integer;
    procedure ReadMap(f:String);
    procedure RefreshMap;
    procedure RefreshPath;
  end;

var
  Form1: TForm1;
  tspace0:array[0..254,0..254{,0..1},-23..23,-23..23] of Integer;
  tspace1:array[0..254,0..254{,0..1},-5..5,-5..5] of Integer;
  from0:array[0..254,0..254{,0..1},-23..23,-23..23] of Pointer;
  from1:array[0..254,0..254{,0..1},-5..5,-23..23] of Pointer;

implementation

uses Math;

{$R *.dfm}

procedure TForm1.Button1Click(Sender: TObject);
begin
  if OpenDialog1.Execute then
  begin
    ReadMap(OpenDialog1.FileName);
  end;
end;

procedure TForm1.ReadMap(f:String);
var sl:TStringList;
    i,j,k,vx,vy:Integer;
begin
  sl:=TStringList.Create;
  sl.LoadFromFile(f);
  sizey:=sl.Count;
  if sizey>0 then
  begin
    sizex:=length(sl[0]);
    for i:=0 to sizey-1 do
     for j:=1 to sizex do
     begin
       case sl[i][j] of
       'X':k:=nic;
       '.':k:=silnice;
       ':':k:=examplesilnice;
       'S':begin
             k:=silnice;
             startx:=j-1;
             starty:=i;
           end;
       'C':k:=cil;
       end;
       mapspace[j-1][i]:=k;
     end;
    Panel1.Enabled:=true;

    Cursor:=crHourGlass;
    Application.ProcessMessages;

    sum:=0;
    for i:=0 to sizex do
     for j:=0 to sizey do
        if mapspace[i][j] in [silnice,examplesilnice,cil] then
        begin
          sum:=sum+47*47+11*11;
          for vx:=-23 to 23 do
          for vy:=-23 to 23 do
          begin
            tspace0[i][j][vx][vy]:=maxword;
          end;
          for vx:=-5 to 5 do
          for vy:=-5 to 5 do
          begin
            tspace1[i][j][vx][vy]:=maxword;
          end;
          heur0[i][j]:=0;
          heur1[i][j]:=0;
        end;
   heurhl:=10;
{    if sum>50000 then heurhl:=heurhl div 2;
    if sum>100000 then heurhl:=heurhl div 2;
    if sum>200000 then heurhl:=heurhl div 2;
    if sum>500000 then heurhl:=10;}
{    if sum>1000000 then heurhl:=1;}

    Cursor:=crDefault;
    Application.ProcessMessages;

    RefreshMap;
    cisto:=true;
  end else
  ShowMessage('S prazdnou mapou daleko nedojedes!');
  sl.Free;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  map:=nil;
  path:=TStringList.Create;
end;

procedure TForm1.RefreshMap;
  procedure DrawMap;
  var i,j:Integer;
      x,y,s,vx,vy:Integer;
      dx,dy:Integer;
      r:String;
      curx,cury:Integer;
  begin
    x:=startx;
    y:=starty;
    s:=0;
    vx:=0;
    vy:=0;
    curx:=0;
    cury:=0;
    Label2.Visible:=false;
    Label2.Caption:='';
    with Image1.Picture.Bitmap.Canvas do
    begin
      if ScrollBar1.Position=0 then
       Brush.Color:=clLime else Brush.Color:=clGreen;
      FillRect(Rect(x*5,y*5,x*5+5,y*5+5));
      if ScrollBar1.Position=0 then
      begin
        Label2.Visible:=true;
        Label2.Left:=x*5+5 - ScrollBox1.HorzScrollBar.ScrollPos;
        Label2.Top:=y*5 - ScrollBox1.VertScrollBar.ScrollPos;
        Label2.Caption:='('+IntToStr(vx)+','+IntToStr(vy)+')'+Label2.Caption;
      end;
      for i:=0 to path.Count-1 do
      begin
        r:=Copy(path[i],1,Pos(',',path[i])-1);
        dx:=StrToInt(r);
        r:=Copy(path[i],Pos(',',path[i])+1,length(path[i]));
        while r[1]=' ' do Delete(r,1,1);
        dy:=StrToInt(r);
        vx:=vx+dx;
        vy:=vy-dy;
        if s=1 then
        begin
          vx:=EnsureRange(vx,-5,5);
          vy:=EnsureRange(vy,-5,5);
        end;
        if (x+vx>=0) and (y+vy>=0) and (x+vx<sizex) and (x+vy<sizey) and
           (mapspace[x+vx][y+vy] in [silnice, examplesilnice, cil]) then
        begin
          x:=x+vx;
          y:=y+vy;
        end else
        begin
          s:=1;
          vx:=0;
          vy:=0;
          if ScrollBar1.Position-1=i then
          begin
            Label2.Caption:='BUM';
            Label2.Left:=x*5+5 - ScrollBox1.HorzScrollBar.ScrollPos;
            Label2.Top:=y*5 - ScrollBox1.VertScrollBar.ScrollPos;
            Label2.Visible:=true;
          end;  
        end;
        if ScrollBar1.Position-1=i then
         begin
            Brush.Color:=clLime;
            curx:=x;
            cury:=y;
            Label2.Visible:=true;
            Label2.Left:=x*5+5 - ScrollBox1.HorzScrollBar.ScrollPos;
            Label2.Top:=y*5 - ScrollBox1.VertScrollBar.ScrollPos;
            Label2.Caption:='('+IntToStr(vx)+','+IntToStr(vy)+')'+Label2.Caption;
         end else
         begin
           Brush.Color:=clGreen;
           if (curx=x) and (cury=y) then
            Brush.Color:=clLime;
         end;
        FillRect(Rect(x*5,y*5,x*5+5,y*5+5));
      end;
    end;
    j:=0;
    for i:=0 to ScrollBar1.Position-2 do
     j:=j+length(path[i])+2;
    Memo1.SelStart:=j;
    if ScrollBar1.Position>0 then
    Memo1.SelLength:=length(path[ScrollBar1.Position-1]);
  end;

var i,j,k,l:Integer;
begin
//   ScrollBox1.AutoScroll:=false;
  Image1.Picture.Bitmap.Width:=sizex*5;
  Image1.Picture.Bitmap.Height:=sizey*5;
  Image1.Picture.Bitmap.Canvas.Brush.Color:=clBlack;
  Image1.Picture.Bitmap.Canvas.FillRect(Rect(0,0,sizex*5,sizey*5));
  for i:=0 to sizex-1 do
   for j:=0 to sizey-1 do
   begin
     with Image1.Picture.Bitmap.Canvas do
     begin
       Brush.Color:=col[mapspace[i][j]];
       if (i=startx) and (j=starty) then
       begin
         Brush.Color:=clBlue;
       end;
{        for k:=-23 to 23 do
         for l:=-23 to 23 do
          if tspace0[i][j][k][l]<maxword then
           begin
             Brush.Color:=clYellow;
           end;}
       FillRect(Rect(i*5,j*5,i*5+5,j*5+5));
     end;
   end;
   if path.Count>0 then
    DrawMap;
   Image1.Width:=Image1.Picture.Width;
   Image1.Height:=Image1.Picture.Height;
   Label1.Left:=Image1.Width;
   Label1.Top:=Image1.Height;
//   ScrollBox1.AutoScroll:=true;
end;

function StepToPtr(x,y:Byte; s:Byte; vx,vy:ShortInt):Pointer;
begin
  Result:=Pointer(x+(y shl 8)+(s shl 16)+((vx+23) shl 17)+((vy+23) shl 23));
end;

function PtrToX(ptr:Pointer):Byte;
begin
  Result:=Integer(ptr) and $FF;
end;

function PtrToY(ptr:Pointer):Byte;
begin
  Result:=(Integer(ptr) shr 8) and $FF;
end;

function PtrToS(ptr:Pointer):Byte;
begin
  Result:=(Integer(ptr) shr 16) and 1;
end;

function PtrToVX(ptr:Pointer):ShortInt;
begin
  Result:=((Integer(ptr) shr 17) and 63)-23;
end;

function PtrToVY(ptr:Pointer):ShortInt;
begin
  Result:=((Integer(ptr) shr 23) and 63)-23;
end;


function GetF(x,y,s,vx,vy:Integer):Pointer;
begin
  Result:=from0[x][y][vx][vy];
  if s=1 then Result:=from1[x][y][vx][vy];
end;

function GetT(x,y,s,vx,vy:Integer):Integer;
begin
  Result:=tspace0[x][y][vx][vy];
  if s=1 then
   if InRange(vx,-5,5) and InRange(vy,-5,5) then
     Result:=tspace1[x][y][vx][vy] else
     Result:=maxword;
end;

procedure SetF(x,y,s,vx,vy:Integer; v:Pointer);
begin
  if s=0 then from0[x][y][vx][vy]:=v else from1[x][y][vx][vy]:=v;
end;

procedure SetT(x,y,s,vx,vy:Integer; v:Integer);
begin
  if s=0 then tspace0[x][y][vx][vy]:=v else tspace1[x][y][vx][vy]:=v;
end;

procedure TForm1.Button2Click(Sender: TObject);
var i,j,k,x,y,s,vx,vy:Integer;
    fr:TQueue;
    step:Pointer;
    nx,ny,ns,nvx,nvy:Integer;
    tx,ty,ts,tvx,tvy:Integer;
    finish:Boolean;
    back:array[0..255*255] of Pointer;
    backcnt:Integer;
    found:Boolean;
    sumsteps:Integer;
begin
  if (sum<500000) or (not cisto) then
  for i:=0 to sizex do
   for j:=0 to sizey do
    if mapspace[i][j] in [cil,examplesilnice,silnice] then
     for vx:=-23 to 23 do
      for vy:=-23 to 23 do
      begin
        tspace0[i][j][vx][vy]:=maxword;
        heur0[i][j]:=0;
        heur1[i][j]:=0;
      end;
  if (not cisto) then    
  for i:=0 to sizex do
   for j:=0 to sizey do
    if mapspace[i][j] in [cil,examplesilnice,silnice] then
     for vx:=-5 to 5 do
      for vy:=-5 to 5 do
      begin
        tspace1[i][j][vx][vy]:=maxword;
      end;
  tspace0[startx][starty][0][0]:=0;
  from0[startx][starty][0][0]:=StepToPtr(startx,starty,0,0,0);

  finish:=mapspace[startx][starty]=cil;
  if finish then
   begin
     fspacex:=startx;
     fspacey:=starty;
     fspaces:=0;
     fspacevx:=0;
     fspacevy:=0;
   end;

  fr:=TQueue.Create;
  fr.Push(StepToPtr(startx,starty,0,0,0));
{  ProgressBar1.Visible:=true;
  sumsteps:=0;}
  while (fr.Count>0) and (not finish) do
  begin
{    ProgressBar1.Position:=round(sumsteps/sum);
    Application.ProcessMessages;}
    step:=fr.Pop;
    x:=PtrToX(step); y:=PtrToY(step); s:=PtrToS(step); vx:=PtrToVX(step); vy:=PtrToVY(step);
    for i:=-1 to 1 do
     for j:=-1 to 1 do
     if not( ((vx+i)=0) and ((vy+j)=0) ) then
     begin
       nvx:=vx+i;
       nvy:=vy+j;
       if s=1 then
        begin
          nvx:=EnsureRange(nvx,-5,5);
          nvy:=EnsureRange(nvy,-5,5);
        end;
       nx:=x+nvx;
       ny:=y+nvy;
       if (nx>=0) and (ny>=0) and (nx<sizex) and (ny<sizey) and
          (mapspace[nx,ny] in [silnice,examplesilnice,cil])  then
        begin
          ns:=s;
        end else
        begin
          nx:=x;
          ny:=y;
          ns:=1;
          nvx:=0;
          nvy:=0;
        end;
        if GetT(nx,ny,ns,nvx,nvy)>GetT(x,y,s,vx,vy)+1 then
        if ((ns=0) and (heur0[nx,ny]<heurhl)) or ((ns=1) and (heur1[nx,ny]<heurhl)) then
        begin
          SetT(nx,ny,ns,nvx,nvy,GetT(x,y,s,vx,vy)+1);
          SetF(nx,ny,ns,nvx,nvy,step);
          if mapspace[nx][ny]=cil then
          begin
            finish:=true;
            fspacex:=nx;
            fspacey:=ny;
            fspaces:=ns;
            fspacevx:=nvx;
            fspacevy:=nvy;
          end else
          fr.Push(StepToPtr(nx,ny,ns,nvx,nvy));
          if ns=0 then
           inc(heur0[nx,ny]) else
           inc(heur1[nx,ny]);
{          inc(sumsteps);}
        end;
     end;
  end;
{  ProgressBar1.Visible:=false;}
  fr.Free;
  backcnt:=1;
  back[0]:=StepToPtr(fspacex,fspacey,fspaces,fspacevx,fspacevy);
  x:=fspacex; y:=fspacey;  s:=fspaces; vx:=fspacevx; vy:=fspacevy;

  if not (mapspace[fspacex][fspacey]=cil) then
  begin
    ShowMessage('nenicesta');
    exit;
  end;
  while (x<>startx) or (y<>starty) do
  begin
    nx:=PtrToX(GetF(x,y,s,vx,vy));
    ny:=PtrToY(GetF(x,y,s,vx,vy));
    ns:=PtrToS(GetF(x,y,s,vx,vy));
    nvx:=PtrToVX(GetF(x,y,s,vx,vy));
    nvy:=PtrToVY(GetF(x,y,s,vx,vy));
    back[backcnt]:=GetF(x,y,s,vx,vy);
    inc(backcnt);
    x:=nx; y:=ny; s:=ns; vx:=nvx; vy:=nvy;
  end;
  back[backcnt]:=GetF(x,y,s,vx,vy);
  path.Clear;
  x:=startx; y:=starty; s:=0; vx:=0; vy:=0;
  for k:=backcnt-2 downto 0 do
  begin
    nx:=PtrToX(back[k]);
    ny:=PtrToY(back[k]);
    ns:=PtrToS(back[k]);
    nvx:=PtrToVX(back[k]);
    nvy:=PtrToVY(back[k]);
    found:=false;
    for i:=-1 to 1 do
     for j:=-1 to 1 do
      if not found then
      begin
       tvx:=vx+i;
       tvy:=vy+j;
       if s=1 then
        begin
          tvx:=EnsureRange(tvx,-5,5);
          tvy:=EnsureRange(tvy,-5,5);
        end;
       tx:=x+tvx;
       ty:=y+tvy;
       if (tx>=0) and (ty>=0) and (tx<sizex) and (ty<sizey) and
          (mapspace[tx,ty] in [silnice,examplesilnice,cil])  then
        begin
          ts:=s;
          tx:=x+tvx;
          ty:=y+tvy;
        end else
        begin
          tx:=x;
          ty:=y;
          ts:=1;
          tvx:=0;
          tvy:=0;
        end;
        if (tx=nx) and (ty=ny) and (ts=ns) and (tvx=nvx) and (tvy=nvy) then
         begin
           path.Add(IntToStr(i)+', '+IntToStr(-j));
           x:=nx;
           y:=ny;
           s:=ns;
           vx:=nvx;
           vy:=nvy;
           found:=true;
         end;
      end;
  end;
  RefreshPath;
  cisto:=false;
end;

procedure TForm1.Button3Click(Sender: TObject);
{TOHLE JE JEN TAKOVEJ TESTIK, NIC TO VLASTNE F PROGRAMU NEDELA}
var p:Pointer;
begin
  p:=StepToPtr(254,253,1,-23,23);
  ShowMessage(IntToStr(PtrToX(p)));
  ShowMessage(IntToStr(PtrToY(p)));
  ShowMessage(IntToStr(PtrToS(p)));
  ShowMessage(IntToStr(PtrToVX(p)));
  ShowMessage(IntToStr(PtrToVY(p)));
end;

procedure TForm1.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  path.Free;
end;

procedure TForm1.RefreshPath;
begin
  Memo1.Lines.Assign(path);
  ScrollBar1.OnChange:=nil;
  ScrollBar1.Max:=path.Count;
  ScrollBar1.Position:=0;
  RefreshMap;
  ScrollBar1.OnChange:=ScrollBar1Change;
end;

procedure TForm1.ScrollBar1Change(Sender: TObject);
begin
  if path.Count>0 then
  RefreshMap;
end;

procedure TForm1.SavePathClick(Sender: TObject);
begin
  if SaveDialog1.Execute then
  begin
    path.SaveToFile(SaveDialog1.FileName);
  end;
end;

procedure TForm1.Button4Click(Sender: TObject);
begin
  if OpenDialog2.Execute then
  begin
    path.LoadFromFile(OpenDialog2.FileName);
    RefreshPath;
  end;
end;

end.
